/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.config.utils.db;

import com.queplix.core.utils.dao.DBRealm;

/**
 * Special class to work with DB DAO realization.
 *
 * @author [ALB] Baranov Andrey
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:17 $
 */
public final class DBRealmManager {

    // Private constructor - blocks instantiation. /
    private DBRealmManager() {
    }

    private static final DBRealm dbRealm = new DBRealm("config.db.properties");

    public static String getSql(String name) {
        return dbRealm.getSql(name);
    }

    public static String getProperty(String name) {
        return dbRealm.getSql(name);
    }
}
