/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eql;

import java.util.ArrayList;

/**
 * <p>Compound Key Value Object</p>
 *
 * @author Baranov Andrey [ALB]
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:19 $
 */

public class CompoundKey
        implements java.io.Serializable {

    private ArrayList keys = new ArrayList(1);

    public void addKey(Object key) {
        keys.add(key);
    }

    public Object getKey(int i) {
        return keys.get(i);
    }

    public int size() {
        return keys.size();
    }

    public Object[] toArray() {
        return size() == 0 ? null:keys.toArray();
    }

    public String toString() {
        return keys.toString();
    }
}