/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eql;

/**
 * <p>EQL Sub Operation Member Field object</p>
 *
 * @author Baranov Andrey [ALB]
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:21 $
 */

public final class EQLReqSubOpMemberField
        implements EQLReqSubOpMember, java.io.Serializable {
    private EQLReqField reqField;

    public EQLReqSubOpMemberField(EQLReqField reqField) {
        this.reqField = reqField;
    }

    public EQLReqField getReqField() {
        return reqField;
    }

    public String toString() {
        return "" + reqField;
    }

    public int hashCode() {
        return reqField.hashCode();
    }

    public boolean equals(Object o) {
        if(!(o instanceof EQLReqSubOpMemberField)) {
            return false;
        }

        if(o == this) {
            return true;
        }

        EQLReqSubOpMemberField member = (EQLReqSubOpMemberField) o;
        return reqField.equals(member.getReqField());
    }
}