/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eql.aggs;

import com.queplix.core.jxb.entity.Entity;
import com.queplix.core.modules.eql.EQLReqAggFunc;
import com.queplix.core.modules.eql.EQLReqField;
import com.queplix.core.modules.eql.EQLReqOp;
import com.queplix.core.modules.eql.EQLReqSubOpMemberField;
import com.queplix.core.modules.eql.error.EQLException;

/**
 * <p>Count Aggregate Function Implementation</p>
 *
 * @author Baranov Andrey [ALB]
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:22 $
 */

public final class CountAggFunc
        extends EQLReqAggFunc {

    //
    // Substitute COUNT field on <code>CountAggEfield</code> field
    //
    public void addParameter(EQLReqOp param)
            throws EQLException {

        EQLReqSubOpMemberField memberField = (EQLReqSubOpMemberField) param
                .getSubOp(0).getMember();
        EQLReqField reqField = memberField.getReqField();
        Entity entity = reqField.getReqEntity().getEntity();

        EQLReqField newReqField = new EQLReqField(entity,
                CountAggEfield.newInstance(entity));
        EQLReqOp newReqOp = new EQLReqOp(newReqField);
        super.addParameter(newReqOp);
    }

}
