/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eqlext.error;

import com.queplix.core.modules.eql.error.EQLException;

/**
 * This exception is thrown on incorrect entity field value.
 *
 * @author [ONZ] Oleg N. Zhovtanyuk
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:39 $
 */
public class IncorrectEfieldValueException extends EQLException {

    /**
     * Constructor.
     *
     * @param entity entity name
     * @param field  entity field name
     * @param value  incorrect field value
     */
    public IncorrectEfieldValueException(String entity, String field,
                                         String value) {
        super("Incorrect value '" + value + "' for field '" + field
                + "' in entity '" + entity + "'");
    }

}
