/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.jeo.gen;

import com.queplix.core.integrator.security.LogonSession;
import com.queplix.core.modules.eql.error.EQLException;
import com.queplix.core.modules.jeo.JEObjectHandler;
import com.queplix.core.modules.jeo.ejb.JEOManagerLocal;

import java.util.List;

/**
 * Role to Users JEO handler.
 *
 * @author [LIV] Ladnev ILya
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:48 $
 */
public class RoleToUserObjectHandler
        extends JEObjectHandler {

    // ======================================================= Inherited methods

    /* (non-Javadoc)
     * @see JEObjectHandler#getEntityName()
     */

    public String getEntityName() {
        return "role_to_users";
    }

    /* (non-Javadoc)
     * @see JEObjectHandler#getObjectClass()
     */
    public Class getObjectClass() {
        return RoleToUserObject.class;
    }

    /**
     * Gets the user's role by user ID.
     *
     * @param manager JEOManager EJB local interface
     * @param ls      LogonSession object with security data
     * @param user_id user's key to search by
     * @return RoleToUser JEO handler, or <code>null</code> if none found
     * @throws EQLException
     */
    public static JEObjectHandler selectHandlerByID(JEOManagerLocal manager,
                                                    LogonSession ls, long user_id)
            throws EQLException {

        String eql = "select /* pageSize=1 */ role_to_users.* where role_to_users.user_id = " + user_id;
        List hndList = manager.select(ls, RoleToUserObjectHandler.class, eql);
        return (hndList != null) ? (JEObjectHandler) hndList.get(0):null;
    }
}
