/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.utils.log;

/**
 * <p>Helper class for working with log (use it only in web container)</p>
 *
 * @author [ALB] Baranov Andrey
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:31:19 $
 */

public class Log
        implements java.io.Serializable {

    // singleton Logger
    private static final AbstractLogger _logger = new AbstractLogger(null) {
    };

    /**
     * Constructor
     */
    private Log() {
    }

    /**
     * Get logger
     *
     * @return logger
     */
    public static AbstractLogger getLog() {
        return _logger;
    }

    /**
     * Get logger
     *
     * @param clazz class
     * @return logger
     */
    public static AbstractLogger getLog(Class clazz) {
        return new AbstractLogger(clazz) {
        };
    }
}
