/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.utils.sql.vendor.mssql;

import com.queplix.core.utils.DateHelper;
import com.queplix.core.utils.sql.generic.DateParserImpl;

import java.util.Date;

/**
 * MS SQL Server date parser.
 *
 * @author [ONZ] Oleg N. Zhovtanyuk
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:31:22 $
 */

public class DateParserMSSQLImpl
        extends DateParserImpl {

    /* (non-Javadoc)
     * @see DateParser#sqlDateFunction(java.util.Date)
     */
    public String sqlDateFunction(Date date) {
        String dateStr = DateHelper.formatDate(date, "dd/MM/yyyy");
        StringBuffer sb = new StringBuffer();
        sb.append("CONVERT(");
        sb.append("DATETIME,'");
        sb.append(dateStr);
        sb.append("', 103)");
        return sb.toString();
    }

}
