/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.utils.sql.vendor.oracle;

import com.queplix.core.utils.DateHelper;
import com.queplix.core.utils.sql.generic.TimestampParserImpl;

import java.util.Date;

/**
 * Oracle timestamp parser.
 *
 * @author [ALB] Baranov Andrey
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:31:23 $
 */

public class TimestampParserOracleImpl
        extends TimestampParserImpl {

    /* (non-Javadoc)
     * @see DateParser#sqlDateFunction(java.util.Date)
     */
    public String sqlDateFunction(Date date) {
        String dateStr = DateHelper.formatDate(date);
        StringBuffer sb = new StringBuffer();
        sb.append("to_date('");
        sb.append(dateStr);
        sb.append("', 'mm/dd/yyyy hh24:mi:ss'");
        sb.append(",'NLS_DATE_LANGUAGE = American')");
        return sb.toString();
    }

}
