/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.client.common.ui;

import com.queplix.core.client.common.event.Event;

/**
 * Context of Toolbar. Intended in order to get tool which allows adding 
 * buttons/icons etc.
 * @author dmitry.antonov
 */
public interface ToolbarContext {
    IconButton addButton(Event event, ButtonData buttonData, boolean toLeft);
    IconButton addMenuButton(Event event, ButtonData buttonData, boolean toLeft,
                                    EventButtonData[] menuItems);
    Icon addIcon(IconData iconData, boolean toLeft);
    void mergeButtons(IconButton first, IconButton second);
}
