/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */
package com.queplix.qwoss.inbox.ejb;

import com.queplix.core.integrator.security.LogonSession;
import com.queplix.core.modules.eql.error.EQLException;
import com.queplix.core.modules.inbox.InboxMessage;

import java.util.Properties;

/**
 * Inbox Manager EJB local home interface.
 *
 * @author Konstantin Mironov
 * @since 8 Dec 2006
 */
public interface InboxManagerLocal
        extends com.queplix.core.modules.inbox.ejb.InboxManagerLocal {

    boolean createTicket(LogonSession ls, InboxMessage inboxMessage);

    boolean updateTicket(LogonSession ls, InboxMessage inboxMessage);

    boolean createLinkInteractionTicket(LogonSession ls, Long interactionID,
                                        Long ticketID) throws EQLException;

    Long createInteraction(LogonSession ls, InboxMessage inboxMessage);

    boolean sendReply(LogonSession ls, InboxMessage inboxMessage,
                      Properties mailHeaders) throws Exception;
} // interface InboxManagerLocal
